﻿Option Strict On

Imports System
Imports System.Console
Imports System.Threading

Public Class ParameterizedThreadDemo
    Public Shared Sub Main()
        ' Parameter zu Object verpacken
        Dim objToParse = New Object() {New String() {"param1", _
                                                     "param2", _
                                                     "param3", _
                                                     "usw."}, _
                                       New Int32() {2, 5, &HCAFE}}
        ' Nun haben wir ein Object-Array mit 2 Einträgen: ein String- und 
        '  ein Integer-Array 

        ' Neuen Thread beschwoeren
        Dim trdParam As Thread = New Thread(AddressOf ParamThread)

        ' Object-Array übergeben 
        '  Da Option Strict aktiv ist, auf jeden Fall Basistyp Object verwenden
        trdParam.Start(objToParse)
        ReadKey()
    End Sub

    Public Shared Sub ParamThread(ByVal objData As Object)
        If objData IsNot Nothing Then

            Dim Args = DirectCast(objData, Object())

            ' Objekt-Array auf die entsprechenden Typen casten
            ' An erster Stelle steht das String-Array...
            Dim strParam() As String = CType(Args(0), String())

            ' ... und an zweiter das Integer-Array
            Dim intParam() As Int32 = CType(Args(1), Int32())

            ' Ausgabe der zwei Parameter Arrays
            Write("{" & strParam(0).ToString)
            For i As Int32 = 1 To strParam.GetUpperBound(0)
                Write(", " & strParam(i).ToString)
            Next
            WriteLine("}")

            Write("{" & intParam(0).ToString)
            For i As Int32 = 1 To intParam.GetUpperBound(0)
                Write(", " & intParam(i).ToString)
            Next
            WriteLine("}")
        End If
    End Sub
End Class
